package com.sooka.component.beetl.tag.cms;

import com.sooka.common.utils.CmsUtil;
import com.sooka.module.web.cms.service.AdService;
import com.sooka.mybatis.model.TCmsAd;
import org.beetl.core.GeneralVarTagBinding;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * @author王硕
 * @site QQ:1468282838
 * @company wang/wangshuo/王硕/WangShuo
 * @create 2020-06-05 16:22
 */
@Service
@Scope("prototype")
public class AdTag extends GeneralVarTagBinding {

    @Autowired
    private AdService service;


    /**
     *
     *<#cms_ad groupId="3" adName="广告测试"  adId="1" var="bean">
     *           ${bean}
     * </#cms_ad>
     *
     * 需做判断  是否为空    广告tag   需要判断  var ="bean"  bena 是否为空  为空的话 说明没有广告  不为空说明有一条广告
     * 只能查出一条广告 如后续需查出多条   可以吧  adName adId 去掉   只查groupId 分组广告
     */
    @SuppressWarnings("unchecked")
    @Override
    public void render() {
        TCmsAd cmsAd = new TCmsAd();

        Integer groupId = (this.getAttributeValue("groupId") instanceof String) ? Integer.parseInt((String) this.getAttributeValue("groupId")) : (Integer) this.getAttributeValue("groupId");
        cmsAd.setGroupId(groupId);
        cmsAd.setAdName((String) this.getAttributeValue("adName"));

        Integer adId = (this.getAttributeValue("adId") instanceof String) ? Integer.parseInt((String) this.getAttributeValue("adId")) : (Integer) this.getAttributeValue("adId");

        cmsAd.setId(adId);

        Date date = new Date();
        cmsAd.setStartDate(date);
        cmsAd.setEndDate(date);

        TCmsAd byIdForDate = service.findByIdForDate(cmsAd);
        if(CmsUtil.isNullOrEmpty(byIdForDate)){
            return;
        }
            this.binds(byIdForDate);
            this.doBodyRender();
    }


}
