package com.sooka.component.beetl.tag.cms;

import com.github.pagehelper.PageInfo;
import com.sooka.common.utils.CmsUtil;
import com.sooka.module.web.cms.service.AdService;
import com.sooka.mybatis.model.TCmsAd;
import org.beetl.core.GeneralVarTagBinding;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author王硕
 * @site QQ:1468282838
 * @company wang/wangshuo/王硕/WangShuo
 * @create 2020-06-05 16:22
 */
@Service
@Scope("prototype")
public class AdTagByGroup extends GeneralVarTagBinding {

    @Autowired
    private AdService service;


    /**
     *
     *	<#cms_ad_group groupId="3" size="10"  orderBy="2" titleLen="20" var="bean">
     * 			${bean}
     * 	</#cms_ad_group>
     *
     *
     * 分组广告
     */
    @SuppressWarnings("unchecked")
    @Override
    public void render() {
        TCmsAd cmsAd = new TCmsAd();

        Integer groupId = (this.getAttributeValue("groupId") instanceof String) ? Integer.parseInt((String) this.getAttributeValue("groupId")) : (Integer) this.getAttributeValue("groupId");
        cmsAd.setGroupId(groupId);
        Integer pageNumber =  Integer.parseInt((CmsUtil.isNullOrEmpty(this.getAttributeValue("pageNumber"))?"1":(String) this.getAttributeValue("pageNumber")));
        Integer pageSize =  Integer.parseInt((String) this.getAttributeValue("size"));
        Integer orderBy =  Integer.parseInt((String) this.getAttributeValue("orderBy"));
        Integer titleLen =  Integer.parseInt((String) this.getAttributeValue("titleLen"));
        if(orderBy%2 != 0){
            cmsAd.setSortId(1);
        }
        else{
            cmsAd.setSortId(2);
        }
        Date date = new Date();
        cmsAd.setStartDate(date);
        cmsAd.setEndDate(date);
        PageInfo<TCmsAd> listByGroup = service.findListByGroup(cmsAd, pageNumber, pageSize);

        if(CmsUtil.isNullOrEmpty(listByGroup.getList())){
            return;
        }
        try {
            this.wrapRender(listByGroup.getList(),titleLen);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void wrapRender(List<TCmsAd> tCmsAdGroup, Integer titleLen) throws Exception {
        for (TCmsAd content : tCmsAdGroup) {
            String title = content.getAdName();
            int length = title.length();
            if (length > titleLen) {
                content.setAdName(title.substring(0, titleLen) + "...");
            }
            this.binds(content);
            this.doBodyRender();
        }
    }



}
