package com.sooka.module.web.cms;
import com.github.pagehelper.PageInfo;
import com.sooka.common.annotation.SysLog;
import com.sooka.common.utils.*;
import com.sooka.component.lucene.util.IndexObject;
import com.sooka.module.web.cms.service.*;
import com.sooka.module.web.cms.vo.*;
import com.sooka.mybatis.model.*;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.WebDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;
import javax.servlet.http.HttpServletRequest;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


/**
 * Description:内容管理控制器
 *
 *
 * @create 2017-04-17
 **/
@Controller
@RequestMapping("/system/cms/enterprise")
public class EnterpriseController {

    @Autowired
    private EnterpriseService enterpriseService;

    @Autowired
    private EnterpriseJbxxService enterpriseJbxxService;

    @Autowired
    private EnterpriseXzxkService enterpriseXzxkService;

    @Autowired
    private EnterpriseXzcfService enterpriseXzcfService;

    @Autowired
    private EnterpriseSxhmdService enterpriseSxhmdService;

    @Autowired
    private EnterpriseZdgzmdService enterpriseZdgzmdService;

    @Autowired
    private EnterpriseHmdService enterpriseHmdService;


    @RequestMapping
    public String index() {
        return "cms/enterprise";
    }
    
    /**双公示信息
     * @param model
     * @return
     */
    @RequestMapping("/goToSgsxx")
    public String goToSgsxx(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
            @RequestParam(value = "pageSize",defaultValue = "10") Integer pageSize,
            Model model) {
  /*      List<TCmsEnterpriseXzcf> xzcfList = enterpriseXzcfService.selectByEnterpriseId(enterpriseId);*/
       /* model.addAttribute("xzcfList",xzcfList);
        model.addAttribute("num",xzcfList.size());*/
    	
    	//查询全部企业的行政许可
    	
    	//信用主体数量,t_cms_enterprise表记录总数(state=1)
    	List<TCmsEnterprise> enterpriseList = enterpriseService.selectAllEnterprise();
    	if(enterpriseList != null) {
    		model.addAttribute("enterpriseList",enterpriseList);
    	}else {
    		model.addAttribute("enterpriseList",0);
    	}
    	
    	//信用主体的行政许可条数,t_cms_enterprise_xzxk表记录总数(state=1)
    	List<TCmsEnterpriseXzxk> xzxkList = this.enterpriseXzxkService.selectAllXzxk();
    	if(xzxkList != null) {
    		model.addAttribute("xzxkList",xzxkList.size());
    	}else {
    		model.addAttribute("xzxkList",0);
    	}
    	
    	TCmsEnterpriseXzxkVo t = new TCmsEnterpriseXzxkVo();
    	PageInfo<TCmsEnterpriseXzxk> p = enterpriseXzxkService.page(pageNumber, pageSize,t);
    	List<TCmsEnterpriseXzxk> list;
        if(p!=null){
            list = p.getList();
            model.addAttribute("model",list);
            model.addAttribute("total",p.getTotal());//总数
            model.addAttribute("pagesize",p.getPageSize());//页数
            model.addAttribute("pagenum",p.getPageNum());
        }else {
            list = new ArrayList<>();
            model.addAttribute("model",list);
            model.addAttribute("total",1);//总数
            model.addAttribute("pagesize",1);//页数
            model.addAttribute("pagenum",1);
        }
        return "www/syjcy/sgsxx";

    }


    @RequestMapping("/page")
    public String page(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                        @RequestParam(value = "pageSize",defaultValue = "50") Integer pageSize,
                       TCmsEnterpriseVo enterprise,
                        Model model){

        model.addAttribute("model",enterpriseService.page(pageNumber,pageSize,enterprise));
        model.addAttribute("pojo",enterprise);
         return "cms/enterprise_list";
    }

    @SysLog("内容添加")
    @RequestMapping("/input")
    public String input(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                        @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                        Model model) {
        model.addAttribute("content",enterpriseService.findById(enterpriseId));
        model.addAttribute("isWindow",isWindow);
        model.addAttribute("message","请填写基础信息");
        return "cms/enterprise_input";
    }

    @RequestMapping("/save")
    @ResponseBody
    public String save(TCmsEnterprise content, HttpServletRequest request) throws SQLException {
        return enterpriseService.save(content);
    }

    /**
     * 去基本信息页面
     * @param enterpriseId
     * @param isWindow
     * @param model
     * @return
     */
    @RequestMapping("/enterpriseJbxx")
    public String enterpriseJbxx(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                 @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                 Model model) {
      /*  if("".equals(enterpriseId) || null == enterpriseId){
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("message","请先保存基础信息");
            return "cms/enterprise_input";
        }else{*/
            model.addAttribute("content",enterpriseJbxxService.findById(enterpriseId));
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("enterpriseId",enterpriseId);
            return "cms/enterprise_jbxx";
        /*}*/
    }

    @RequestMapping("/saveJbxx")
    @ResponseBody
    public String saveJbxx(TCmsEnterpriseJbxx content, HttpServletRequest request) throws SQLException {
        if(content.getJbxxId()!=null) {
            return enterpriseJbxxService.update(content);
        }
        return enterpriseJbxxService.save(content);
    }



    /**
     * 去行政许可页面

     * @param model
     * @return
     */

    @RequestMapping("/enterpriseXzxkList")
    public String page(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                       @RequestParam(value = "pageSize",defaultValue = "50") Integer pageSize,
                       TCmsEnterpriseXzxkVo enterprise,@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                       Model model){

        model.addAttribute("model",enterpriseXzxkService.page(pageNumber,pageSize,enterprise));
        model.addAttribute("pojo",enterprise);
        model.addAttribute("enterpriseId",enterpriseId);
        return "cms/enterprise_xzxk_list";
    }

    @RequestMapping("/enterpriseXzxk")
    public String enterpriseXzxk(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                 @RequestParam(value = "xzxkId",required = false) Long xzxkId,
                                 @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                 Model model) {
       /* if("".equals(enterpriseId) || null == enterpriseId){
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("message","请先保存基础信息");
            return "cms/enterprise_input";
        }else {*/
        if(xzxkId!=null) {
            TCmsEnterpriseXzxk content = enterpriseXzxkService.findById(xzxkId);
            if(content != null || !"".equals(content)){
                model.addAttribute("content",content);
            }
        }
        model.addAttribute("isWindow",isWindow);
        model.addAttribute("enterpriseId",enterpriseId);
        return "cms/enterprise_xzxk";
        /*   }*/
    }

    @RequestMapping("/saveXzxk")
    @ResponseBody
    public String saveXzxk(TCmsEnterpriseXzxk content, HttpServletRequest request) throws SQLException {
        if(content.getXzxkId()!=null) {
            return enterpriseXzxkService.update(content);
        }
        return enterpriseXzxkService.save(content);
    }

    /**
     * @param enterpriseId
     * @param isWindow
     * @param model
     * @return
     */
    @RequestMapping("/selectXzxkByEnterpriseId")
    public String selectByXzxkId(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                 @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                 Model model) {
        TCmsEnterprise enterprise  = enterpriseService.selectByEnterpriseId(enterpriseId);
        List<TCmsEnterpriseXzxk> xzxkList = enterpriseXzxkService.selectByEnterpriseId(enterpriseId);
        model.addAttribute("enterprise",enterprise);
        model.addAttribute("xzxkList",xzxkList);
        model.addAttribute("num",xzxkList.size());
        model.addAttribute("isWindow",isWindow);
        model.addAttribute("enterpriseId",enterpriseId);
        return "www/syjcy/enterprise_xzxk";

    }
    
    /**
     * 
     * @Title: selectBySxhmdId
     * @Description: 守信红名单查询
     * @param enterpriseId
     * @param isWindow
     * @param model
     * @return
     * @author wangjinsheng
     * @date 2020-01-22 11:46:37
     */

    @RequestMapping("/selectBySxhmdId")
    public String selectBySxhmdId(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                 @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                 Model model) {
        TCmsEnterprise enterprise  = enterpriseService.selectByEnterpriseId(enterpriseId);
        List<TCmsEnterpriseSxhmd> sxhmdList = enterpriseSxhmdService.selectByEnterpriseId(enterpriseId);
        model.addAttribute("enterprise",enterprise);
        model.addAttribute("sxhmdList",sxhmdList);
        model.addAttribute("num",sxhmdList.size());
        model.addAttribute("isWindow",isWindow);
        model.addAttribute("enterpriseId",enterpriseId);
        return "www/syjcy/enterprise_sxhmd";

    }



    /**
     * 去行政处罚页面
     * @param enterpriseId
     * @param model
     * @return
     */
    @RequestMapping("/enterpriseXzcfList")
    public String enterpriseXzcfList(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                                     @RequestParam(value = "pageSize",defaultValue = "50") Integer pageSize,
                                     TCmsEnterpriseXzcfVo enterprise, @RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                     Model model){

        model.addAttribute("model",enterpriseXzcfService.page(pageNumber,pageSize,enterprise));
        model.addAttribute("pojo",enterprise);
        model.addAttribute("enterpriseId",enterpriseId);
        return "cms/enterprise_xzcf_list";
    }


    @RequestMapping("/enterpriseXzcf")
    public String enterpriseXzcf(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                 @RequestParam(value = "xzcfId",required = false) Long xzcfId,
                                 @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                 Model model) {
      /*  if("".equals(enterpriseId) || null == enterpriseId){
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("message","请先保存基础信息");
            return "cms/enterprise_input";
        }else {*/
        if(xzcfId!=null) {
            TCmsEnterpriseXzcf content = enterpriseXzcfService.findById(enterpriseId);
            if(content != null || !"".equals(content)){
                model.addAttribute("content",content);
            }
        }
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("enterpriseId",enterpriseId);
            return "cms/enterprise_xzcf";
       /* }*/
    }

    @RequestMapping("/saveXzcf")
    @ResponseBody
    public String saveXzcf(TCmsEnterpriseXzcf content, HttpServletRequest request) throws SQLException {
        if(content.getXzcfId()!=null) {
            return enterpriseXzcfService.update(content);
        }
        return enterpriseXzcfService.save(content);
    }

    /**
     * @param isWindow
     * @param model
     * @return
     */
    @RequestMapping("/selectXzcfByEnterpriseId")
    public String selectByEnterpriseId(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                 @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                 Model model) {
        TCmsEnterprise enterprise  = enterpriseService.selectByEnterpriseId(enterpriseId);
        List<TCmsEnterpriseXzcf> xzcfList = enterpriseXzcfService.selectByEnterpriseId(enterpriseId);
        model.addAttribute("enterprise",enterprise);
        model.addAttribute("xzcfList",xzcfList);
        model.addAttribute("num",xzcfList.size());
        model.addAttribute("isWindow",isWindow);
        model.addAttribute("enterpriseId",enterpriseId);
        return "www/syjcy/enterprise_xzcf";

    }

    /**
     * 去守信红名单页面
     * @param enterpriseId
     * @param model
     * @return
     */
    @RequestMapping("/enterpriseSxhmdList")
    public String enterpriseSxhmdList(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                                      @RequestParam(value = "pageSize",defaultValue = "50") Integer pageSize,
                                      TCmsEnterpriseSxhmdVo enterprise, @RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                      Model model){

        model.addAttribute("model",enterpriseSxhmdService.page(pageNumber,pageSize,enterprise));
        model.addAttribute("pojo",enterprise);
        model.addAttribute("enterpriseId",enterpriseId);
        return "cms/enterprise_sxhmd_list";
    }

    @RequestMapping("/enterpriseSxhmd")
    public String enterpriseSxhmd(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                  @RequestParam(value = "sxhmdId",required = false) Long sxhmdId,
                                  @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                  Model model) {
       /* if("".equals(enterpriseId) || null == enterpriseId){
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("message","请先保存基础信息");
            return "cms/enterprise_input";
        }else {*/
        if(sxhmdId!=null) {
            TCmsEnterpriseSxhmd content = enterpriseSxhmdService.findById(enterpriseId);
            if(content != null || !"".equals(content)){
                model.addAttribute("content",content);
            }
        }
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("enterpriseId",enterpriseId);
            return "cms/enterprise_sxhmd";
      /*  }*/
    }

    @RequestMapping("/saveSxhmd")
    @ResponseBody
    public String saveSxhmd(TCmsEnterpriseSxhmd content, HttpServletRequest request) throws SQLException {
        if(content.getSxhmdId()!=null) {
            return enterpriseSxhmdService.update(content);
        }
        return enterpriseSxhmdService.save(content);
    }

    @RequestMapping("/goToSxhmd")
    public Object goToSxhmd(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                                @RequestParam(value = "pageSize",defaultValue = "10") Integer pageSize,
                                @RequestParam(value = "keyword",required = false)String keyword,Model model) {
        PageInfo p = enterpriseSxhmdService.selectEnterprise(pageNumber,pageSize,keyword);
        List<IndexObject> enterpriseList;
        if(p!=null){
            enterpriseList = p.getList();
            model.addAttribute("enterpriseList",enterpriseList);
            model.addAttribute("total",p.getTotal());//总数
            model.addAttribute("pagesize",p.getPageSize());//页数
            model.addAttribute("pagenum",p.getPageNum());
            model.addAttribute("keyword",keyword);
        }else {
            enterpriseList = new ArrayList<>();
            model.addAttribute("enterpriseList",enterpriseList);
            model.addAttribute("total",1);//总数
            model.addAttribute("pagesize",1);//页数
            model.addAttribute("pagenum",1);
            model.addAttribute("keyword",keyword);
        }
        return "www/syjcy/enterprise_sxhmd";
    }

    /**
     * 去重点关注名单页面
     * @param enterpriseId
     * @param model
     * @return
     */
    @RequestMapping("/enterpriseZdgzmdList")
    public String enterpriseZdgzmdList(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                                       @RequestParam(value = "pageSize",defaultValue = "50") Integer pageSize,
                                       TCmsEnterpriseZdgzmdVo enterprise, @RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                       Model model){

        model.addAttribute("model",enterpriseZdgzmdService.page(pageNumber,pageSize,enterprise));
        model.addAttribute("pojo",enterprise);
        model.addAttribute("enterpriseId",enterpriseId);
        return "cms/enterprise_zdgzmd_list";
    }

    @RequestMapping("/enterpriseZdgzmd")
    public String enterpriseZdgzmd(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,@RequestParam(value = "zdgzmdId",required = false) Long zdgzmdId,
                                   @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                   Model model) {
     /*   if("".equals(enterpriseId) || null == enterpriseId){
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("message","请先保存基础信息");
            return "cms/enterprise_input";

        }else {*/
        if(zdgzmdId!=null) {
            TCmsEnterpriseZdgzmd content = enterpriseZdgzmdService.findById(enterpriseId);
            if(content != null || !"".equals(content)){
                model.addAttribute("content",content);
            }
        }
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("enterpriseId",enterpriseId);
            return "cms/enterprise_zdgzmd";
      /*  }*/
    }

    @RequestMapping("/saveZdgzmd")
    @ResponseBody
    public String saveZdgzmd(TCmsEnterpriseZdgzmd content, HttpServletRequest request) throws SQLException {
        if(content.getZdgzmdId()!=null) {
            return enterpriseZdgzmdService.update(content);
        }
        return enterpriseZdgzmdService.save(content);
    }


    /**
     * 去失信黑名单页面
     * @param enterpriseId
     * @param model
     * @return
     */
    @RequestMapping("/enterpriseHmdList")
    public String enterpriseHmdList(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                                       @RequestParam(value = "pageSize",defaultValue = "50") Integer pageSize,
                                    TCmsEnterpriseHmdVo enterprise, @RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                       Model model){

        model.addAttribute("model",enterpriseHmdService.page(pageNumber,pageSize,enterprise));
        model.addAttribute("pojo",enterprise);
        model.addAttribute("enterpriseId",enterpriseId);
        return "cms/enterprise_hmd_list";
    }

    @RequestMapping("/enterpriseHmd")
    public String enterpriseHmd(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                Model model) {
       /* if("".equals(enterpriseId) || null == enterpriseId){
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("message","请先保存基础信息");
            return "cms/enterprise_input";

        }else {*/
            model.addAttribute("content",enterpriseHmdService.findById(enterpriseId));
            model.addAttribute("isWindow",isWindow);
            model.addAttribute("enterpriseId",enterpriseId);
            return "cms/enterprise_hmd";
      /*  }*/
    }

    @RequestMapping("/saveHmd")
    @ResponseBody
    public String saveHmd(TCmsEnterpriseHmd content, HttpServletRequest request) throws SQLException {
        if(content.getHmdId()!=null) {
            return enterpriseHmdService.update(content);
        }
        return enterpriseHmdService.save(content);
    }


    @SysLog("内容删除")
    @RequiresPermissions("content:delete")
    @RequestMapping("/delete")
    @ResponseBody
    public String delete(@RequestParam(value = "ids",required = false) Long[] ids) {
        return enterpriseService.delete(ids);
    }


    @RequestMapping("/recovery")
    @ResponseBody
    public String recovery(@RequestParam(value = "ids",required = false) Long[] ids) {
        return enterpriseService.recovery(ids);
    }

    @RequestMapping("/excel")
    public ModelAndView excel(){
        ExcelUtil.exports2007("123",enterpriseService.page(1,20,new TCmsEnterpriseVo()).getList());
        return null;
    }


    @InitBinder
    public void initBinder(WebDataBinder binder) {
        DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        dateFormat.setLenient(true);
        binder.registerCustomEditor(Date.class, new CustomDateEditor(dateFormat, true));
    }

    /**
     * 统一社会代码查询
     * @param pageNumber
     * @param pageSize
     * @param keyword
     * @param model
     * @return
     */
    @RequestMapping("/goToTyshdmcdx")
    public Object goToTyshdmcdx(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                                @RequestParam(value = "pageSize",defaultValue = "10") Integer pageSize,
                                @RequestParam(value = "keyword",required = false)String keyword,Model model) {
        PageInfo p = enterpriseService.selectEnterprise(pageNumber,pageSize,keyword);
        List<IndexObject> enterpriseList;
        if(p!=null){
            enterpriseList = p.getList();
            model.addAttribute("enterpriseList",enterpriseList);
            model.addAttribute("total",p.getTotal());//总数
            model.addAttribute("pagesize",p.getPageSize());//页数
            model.addAttribute("pagenum",p.getPageNum());
            model.addAttribute("keyword",keyword);
        }else {
            enterpriseList = new ArrayList<>();
            model.addAttribute("enterpriseList",enterpriseList);
            model.addAttribute("total",1);//总数
            model.addAttribute("pagesize",1);//页数
            model.addAttribute("pagenum",1);
            model.addAttribute("keyword",keyword);
        }
        return "www/syjcy/tyshxydmcx";
    }

    /**
     * @param enterpriseId
     * @param isWindow
     * @param model
     * @return
     */
    @RequestMapping("/selectEnterpriseByEnterpriseId")
    public String selectEnterpriseByEnterpriseId(@RequestParam(value = "enterpriseId",required = false) Long enterpriseId,
                                 @RequestParam(value = "isWindow",defaultValue = "NO") String isWindow,
                                 Model model) {
        TCmsEnterprise enterprise  = enterpriseService.selectByEnterpriseId(enterpriseId);
        TCmsEnterpriseJbxx jbxx = enterpriseJbxxService.selectByEnterpriseId(enterpriseId);
        model.addAttribute("enterprise",enterprise);
        model.addAttribute("jbxx",jbxx);
        model.addAttribute("isWindow",isWindow);
        model.addAttribute("enterpriseId",enterpriseId);
        return "www/syjcy/enterprise_xxgl";

    }
    
    
    
    
    
    
}
