package com.sooka.module.web.cms;


import com.github.pagehelper.PageInfo;
import com.sooka.common.upload.UploadComponent;
import com.sooka.common.upload.bean.UploadBean;
import com.sooka.common.utils.DateUtil;
import com.sooka.common.utils.ObjectExcelView;
import com.sooka.common.utils.PageData;
import com.sooka.module.web.cms.service.SiteService;
import com.sooka.module.web.cms.service.XfService;
import com.sooka.mybatis.model.TCmsSite;
import com.sooka.mybatis.model.TCmsXf;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.*;

@Controller
@RequestMapping("/cms/xf")
public class XfController  {

    @Autowired
    private XfService xfService;
    @Autowired
    private UploadComponent uploadComponent;
    
    @Autowired
    private SiteService siteService;

    @RequestMapping("/input")
    public String input(@RequestParam(value = "id",required = false) Integer Id, Model model) {
        if(Id!=null) {
            model.addAttribute("xf",xfService.findById(Id));
        }
        return "cms/xf_input";
    }



    @RequestMapping
    public String index(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                        @RequestParam(value = "pageSize",defaultValue = "100") Integer pageSize,
                        TCmsXf pojo, Model model){
        PageInfo<TCmsXf> list = xfService.page(pageNumber,pageSize,pojo);
       for(int i=0;i<list.getList().size();i++){
            String createTime = list.getList().get(i).getCreateTime().substring(0,10);
            list.getList().get(i).setCreateTime(createTime);
        }
        model.addAttribute("model",list);
        model.addAttribute("pojo",pojo);
        return "cms/xf_list";
    }


    @RequestMapping("/save")
    @ResponseBody
    public String save(@RequestParam("myfile") MultipartFile multipartFile,
                         HttpServletRequest request,TCmsXf pojo){
        UploadBean result = uploadComponent.uploadFile(multipartFile,request);
        pojo.setFile(result.getFileUrl());
        if(pojo.getId()!=null){
            xfService.update(pojo);
        }
        return xfService.save(pojo);

    }

    @RequestMapping("/saveSj")
    @ResponseBody
    public String saveSj(TCmsXf pojo){
        if(pojo.getId()!=null){
            xfService.update(pojo);
        }
        return xfService.save(pojo);

    }
    @RequestMapping("/delete")
    @ResponseBody
    public String delete(@RequestParam(value = "ids",required = false) Integer[] ids) throws SQLException {
        return xfService.delete(ids);
    }


    @RequestMapping("/selectAll")
    @ResponseBody
    public Object selectAll(){
        List<TCmsXf> list= xfService.findAll();
        return list;

    }


    /*
     * 导出到excel
     * @return
     */
    @RequestMapping(value="/excel")
    public ModelAndView exportExcel(String startDate,String endDate){
        ModelAndView mv = new ModelAndView();
        try{
            Map<String,Object> dataMap = new HashMap<String,Object>();
            List<String> titles = new ArrayList<String>();
            titles.add("姓名");	        //1
            titles.add("性别");	        //2
            titles.add("电话");	        //3
            titles.add("身份证号");    //4
            titles.add("居住地址");    //5
            titles.add("基本情况");    //6
            titles.add("具体诉求");    //7
            titles.add("状态");        //8
            titles.add("结果告知");    //9
            titles.add("文件");	        //10
            titles.add("创建时间");	    //11

            dataMap.put("titles", titles);
            List<TCmsXf> varOList =  xfService.exportExcel(startDate,endDate);
            List<PageData> varList = new ArrayList<PageData>();

            for (TCmsXf tCmsXf : varOList) {
                PageData vpd = new PageData();
                vpd.put("var1", tCmsXf.getName());	                                       //1
                vpd.put("var2", "0".equals(tCmsXf.getSex())?"男":"女");                  //2
                vpd.put("var3", tCmsXf.getPhone());                     	               //3
                vpd.put("var4", tCmsXf.getIDNumber());	                                   //4
                vpd.put("var5", tCmsXf.getResidential_address());	                       //5
                vpd.put("var6", tCmsXf.getBasic_information());         	               //6
                vpd.put("var7", tCmsXf.getSpecific_demands());	                           //7
                vpd.put("var8", "0".equals(tCmsXf.getState())?"未反馈":"已反馈");       //8
                vpd.put("var9", tCmsXf.getResult_notification());	                       //9
                vpd.put("var10", tCmsXf.getFile());	                                       //10
                vpd.put("var11", tCmsXf.getCreateTime().substring(0,10));	                               //11
                varList.add(vpd);
            }
            dataMap.put("varList", varList);
            ObjectExcelView erv = new ObjectExcelView();
            mv = new ModelAndView(erv,dataMap);
        } catch(Exception e){
            e.printStackTrace();
        }
        return mv;
    }

    @RequestMapping("/selectXfck")
    public String selectXfck(){
        return "www/jlrd/xfck";
    }

    @RequestMapping("/selectSjXfck")
    public String selectSjXfck(@RequestParam("siteId") Integer siteId,Model model){
    	TCmsSite site = siteService.findById(siteId);
    	model.addAttribute("site",site);
        return "www/jlrd-mobile/xfck";
    }

    @RequestMapping("/selectWyly")
    public String selectWyly(){
        return "www/jlrd/wyly";
    }

    @RequestMapping("/selectXxcx")
    public String selectXxcx(){
        return "www/jlrd/xfcx";
    }

    @RequestMapping("/selectSjWyly")
    public String selectSjWyly(@RequestParam("siteId") Integer siteId,Model model){
    	TCmsSite site = siteService.findById(siteId);
    	model.addAttribute("site",site);
        return "www/jlrd-mobile/wyly";
    }

    @RequestMapping("/selectSjXxcx")
    public String selectSjXxcx(@RequestParam("siteId") Integer siteId,Model model){
    	TCmsSite site = siteService.findById(siteId);
    	model.addAttribute("site",site);
        return "www/jlrd-mobile/xfcx";
    }

    @RequestMapping("/hf")
    public String hf( Integer id, Model model){
        model.addAttribute("xf",xfService.findById(id));
        return "cms/xf_hf";
    }

    @RequestMapping("/selectInfo")
    public String selectInfo( Integer id, Model model){
        model.addAttribute("xf",xfService.findById(id));
        return "cms/xf_info";
    }

    @RequestMapping("/updateResultNotification")
    @ResponseBody
    public String updateResultNotification(TCmsXf pojo){
            return xfService.updateResultNotification(pojo);
    }

    @RequestMapping("/selectXfxx")
    @ResponseBody
    public Object selectXfxx(TCmsXf xf){
        List<TCmsXf> list= xfService.selectXfxx(xf);
        return list;
    }

}
