package com.sooka.module.web.cms;


import com.sooka.common.constant.CmsConst;
import com.sooka.common.exception.CmsException;
import com.sooka.common.utils.CmsUtil;
import com.sooka.common.utils.ControllerUtil;
import com.sooka.common.utils.JsonUtil;
import com.sooka.common.utils.StrUtil;
import com.sooka.module.web.cms.service.VoteLogService;
import com.sooka.module.web.cms.service.VoteService;
import com.sooka.module.web.cms.service.YjfbService;
import com.sooka.module.web.cms.vo.TCmsContentVo;
import com.sooka.module.web.cms.vo.VoteVo;
import com.sooka.module.web.system.vo.UserVo;
import com.sooka.mybatis.model.*;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authz.UnauthenticatedException;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.apache.shiro.subject.Subject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

@Controller
@RequestMapping("/cms/yjfb")
public class YjfbController {

    @Autowired
    private YjfbService yjfbService;

    @RequiresPermissions("content:admin")
    @RequestMapping("/page")
    public String index(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                        @RequestParam(value = "pageSize",defaultValue = "100") Integer pageSize,
                        TCmsYjfb pojo, Model model){
        model.addAttribute("model",yjfbService.page(pageNumber,pageSize,pojo));
        model.addAttribute("pojo",pojo);
        return "cms/yjfb_list";
    }

    @RequestMapping("/save")
    @ResponseBody
    public String save(TCmsYjfb pojo){
        if(pojo.getId()!=null){
            yjfbService.update(pojo);
        }
        return yjfbService.save(pojo);
    }

    @RequestMapping("/delete")
    @ResponseBody
    public String delete(@RequestParam(value = "ids",required = false) Integer[] ids) throws SQLException {
        return yjfbService.delete(ids);
    }




}
