package com.sooka.module.web.cms;


import com.sooka.common.constant.CmsConst;
import com.sooka.common.utils.CmsUtil;
import com.sooka.common.utils.ControllerUtil;
import com.sooka.module.web.cms.service.DbtService;
import com.sooka.module.web.cms.service.DbtUserService;
import com.sooka.module.web.cms.service.SiteService;
import com.sooka.module.web.cms.vo.TCmsContentDbtVo;
import com.sooka.module.web.system.vo.UserVo;
import com.sooka.mybatis.model.TCmsContentDbt;
import com.sooka.mybatis.model.TCmsSite;

import org.apache.shiro.authz.UnauthenticatedException;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping("/system/cms/dbt")
public class dbtController {

    /*@Autowired
    private DbtUserService dbtUserService;*/

    @Autowired
    private DbtService dbtService;
    
    @Autowired
    private SiteService siteService;

	 @Autowired
	 private DbtUserService dbtUserService;


    @RequiresPermissions("dbt:admin")
    @RequestMapping
    public String index(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                        @RequestParam(value = "pageSize",defaultValue = "100") Integer pageSize,
                        TCmsContentDbt dbt,
                        Model model){
        model.addAttribute("model",dbtService.page(pageNumber,pageSize,dbt));
        model.addAttribute("pojo",dbt);
        return "cms/dbt_list";
    }

    @RequiresPermissions("dbt:admin")
    @RequestMapping("/page")
    public String page(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,
                       @RequestParam(value = "pageSize",defaultValue = "50") Integer pageSize,
                       TCmsContentDbtVo dbt,
                       Model model){

        UserVo userVo = ((UserVo) ControllerUtil.getHttpSession().getAttribute(CmsConst.SITE_USER_SESSION_KEY));
        if(CmsUtil.isNullOrEmpty(userVo)) {
            throw  new UnauthenticatedException();
        }
        model.addAttribute("model",dbtService.page(pageNumber,pageSize,dbt));
        model.addAttribute("pojo",dbt);
        return "cms/dbt_list";
    }

    @RequestMapping("/dbtlist")
    public String dbtlist(@RequestParam("siteId") Integer siteId,Model model) {
    	TCmsSite site = siteService.findById(siteId);
    	model.addAttribute("list",dbtService.findAll());
    	model.addAttribute("site",site);
        return "www/jlrd/jlrd_zucheng_dbt";
    }
    
    @RequestMapping("/dbtitemList")
    public String dbtUserList(@RequestParam("dbtId")Integer dbtId, Model model) {
    	if (dbtId!=null) {
    		//model.addAttribute("dbtUser",dbtUserService.(dbtId));
    		model.addAttribute("dbtId",dbtId);
    	}
    	return "1";
    }
    
    @RequestMapping("/input")
    public String input(@RequestParam(value = "id",required = false) Integer Id, Model model) {
        if (Id!=null) {
            model.addAttribute("dbt",dbtService.findById(Id));
        }
        return "cms/dbt_input";
    }

    @RequestMapping("/save")
    @ResponseBody
    public String save(TCmsContentDbt pojo) {
        if(pojo.getDbtId()!=null) {
            return dbtService.update(pojo);
        }
        return dbtService.save(pojo);
    }
    
    @RequestMapping("/savecy")
    @ResponseBody
    public String savecy(TCmsContentDbt pojo) {
        if(pojo.getDbtId()!=null) {
            return dbtService.update(pojo);
        }
        return dbtService.save(pojo);
    }
    
    
    @RequestMapping("/delete")
    @ResponseBody
    public String delete(@RequestParam(value = "ids",required = false)Integer[] ids) {
        return dbtService.delete(ids);
    }
}
