package com.sooka.module.web.cms.service.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.stereotype.Service;

import com.alibaba.druid.util.StringUtils;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sooka.common.utils.JsonUtil;
import com.sooka.module.web.cms.service.MailService;
import com.sooka.module.web.system.vo.UserVo;
import com.sooka.mybatis.mapper.TCmsMailMapper;
import com.sooka.mybatis.model.TCmsMail;

/**
 * 
 * @author Administrator
 *
 */
@Service
public class MailServiceImpl implements MailService {

    @Autowired
    private TCmsMailMapper mailMapper;
    
    @Override
	public PageInfo<TCmsMail> pageInbox(Integer pageNumber, Integer pageSize, Integer receiverId, TCmsMail pojo) {
		PageHelper.startPage(pageNumber, pageSize);
		return new PageInfo<>(mailMapper.pageInbox(receiverId, pojo.getTheme()));
	}
    
    @Override
	public PageInfo<TCmsMail> pageOutbox(Integer pageNumber, Integer pageSize, Integer senderId, TCmsMail pojo) {
    	PageHelper.startPage(pageNumber, pageSize);
		return new PageInfo<>(mailMapper.pageOutbox(senderId, pojo.getTheme()));
	}

	@Override
	public String save(TCmsMail pojo) {
		if(mailMapper.insert(pojo) > 0) {
			return JsonUtil.toSUCCESS("操作成功", "outbox-tab", true);
		}
		return JsonUtil.toERROR("操作失败");
	}

	@Override
	public String update(TCmsMail pojo) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String delete(Integer[] ids) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public TCmsMail findById(Integer id) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<TCmsMail> findList(TCmsMail pojo) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<TCmsMail> findAll() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public PageInfo<TCmsMail> page(Integer pageNumber, Integer pageSize, TCmsMail pojo) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public PageInfo<TCmsMail> page(Integer pageNumber, Integer pageSize) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String saveList(String receiverIds, UserVo userVo, TCmsMail mail, String content, String file) {
		boolean flag = false;
		List<TCmsMail> listVo = new ArrayList<TCmsMail>();
		String[] str = receiverIds.split(",");
		for(String receiverId : str) {
			TCmsMail vo = new TCmsMail();
			vo.setSenderId(userVo.getUserId());
			vo.setSenderName(userVo.getUsername());
			vo.setReceiverId(Integer.valueOf(receiverId));
			vo.setTheme(mail.getTheme());
			vo.setState(0);
			vo.setContent(content);//
			vo.setFile(mail.getFile());
			vo.setSendTime(new Date());
			vo.setSiteId(userVo.getSiteId());
			vo.setIsDelete(0);
			listVo.add(vo);
		}
		flag = mailMapper.saveList(listVo)>0;
		if(flag) {
			return JsonUtil.toSUCCESS("发送成功", "outbox-tab", true);
		}
		return JsonUtil.toERROR("发送失败");
	}

	@Override
	public TCmsMail findByMailId(Integer mailId, String flag) {
		TCmsMail mail = mailMapper.findByMailId(mailId);
		/**
		 * 判断是否需要更改信件状态
		 * 已发送 查看不更改状态flag=out
		 * 收件箱 查看更新状态,如果是未读信件，将状态变为已读，flag为空
		 * 状态state，1-已读，0-未读，
		 */
		if(StringUtils.isEmpty(flag) && mail.getState() == 0) {
			mailMapper.updateState(1,mail.getMailId());
		}
		return mail;
	}

	@Override
	public Integer AllCount(Integer userId) {
		return mailMapper.AllCount(userId);
	}

	@Override
	public String deleteMails(Integer[] ids, Integer flag) {
		boolean flag_ = false;
		if(ids!=null&&ids.length>0) {
			for(Integer mailId : ids) {
				flag_ = mailMapper.deleteByPrimaryKey(mailId) > 0;
			}
		}
		if(flag_) {
			if(flag == 0) {
				return JsonUtil.toSUCCESS("发送成功", "outbox-tab", true);
			}
			return JsonUtil.toSUCCESS("发送成功", "inbox-tab", true);
		}
		return JsonUtil.toERROR("发送失败");
	}

}
