package com.sooka.module.web.cms.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sooka.common.utils.JsonUtil;
import com.sooka.module.web.cms.service.XfService;
import com.sooka.mybatis.mapper.TCmsXfMapper;
import com.sooka.mybatis.model.TCmsXf;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

@Service
public class XfServiceImpl implements XfService {

    @Autowired
    private TCmsXfMapper xfMapper;



    @Override
    public String save(TCmsXf pojo) {
        pojo.setCreatetime(new Date());
        pojo.setState("0");
        if(xfMapper.insertSelective(pojo)>0){
            return JsonUtil.toSUCCESS("保存成功!","lbt-tab",true);
        }
        return JsonUtil.toERROR("保存失败!");
    }

    @Override
    public String update(TCmsXf pojo) {
        pojo.setCreatetime(new Date());
        pojo.setState("0");
        if(xfMapper.updateByPrimaryKeySelective(pojo)>0){
            return JsonUtil.toSUCCESS("操作成功!","lbt-tab",true);
        }
        return JsonUtil.toERROR("操作失败!");
    }

    @Override
    public String updateResultNotification(TCmsXf xf){
        xf.setCreatetime(new Date());
        xf.setState("1");
        if(xfMapper.updateResultNotification(xf)>0){
            return JsonUtil.toSUCCESS("操作成功!","lbt-tab",true);
        }
        return JsonUtil.toERROR("操作失败!");
    }

    @Override
    public String delete(Integer[] ids) {
        if(ids!=null&&ids.length>0){
            for(Integer id:ids){
                xfMapper.deleteByPrimaryKey(id);
                return JsonUtil.toSUCCESS("删除成功!","lbt-tab",true);
            }
        }
        return JsonUtil.toERROR("删除失败!");
    }

    @Override
    public TCmsXf findById(Integer id) {
        return xfMapper.selectByPrimaryKey(id);
    }

    @Override
    public List<TCmsXf> findList(TCmsXf pojo) {
        return xfMapper.select(pojo);
    }

    @Override
    public List<TCmsXf> findAll() {
        return xfMapper.selectAll();
    }

    @Override
    public PageInfo<TCmsXf> page(Integer pageNumber, Integer pageSize, TCmsXf pojo) {
        PageHelper.startPage(pageNumber,pageSize);
        return new PageInfo(xfMapper.selectByCondition(pojo));
    }



    @Override
    public PageInfo<TCmsXf> page(Integer pageNumber, Integer pageSize) {
        PageHelper.startPage(pageNumber,pageSize);
        return new PageInfo<>(findAll());
    }

    @Override
    public  List<TCmsXf> selectXfxx(TCmsXf xf) {
        return this.xfMapper.selectXfxx(xf);
    }

    @Override
    public  List<TCmsXf> exportExcel(String startDate,String endDate) {
        return this.xfMapper.exportExcel(startDate,endDate);
    }
}
