package com.sooka.module.web.cms.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sooka.common.utils.JsonUtil;
import com.sooka.module.web.cms.service.YjfbService;
import com.sooka.mybatis.mapper.TCmsYjfbMapper;
import com.sooka.mybatis.model.TCmsContent;
import com.sooka.mybatis.model.TCmsYjfb;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class YjfbServiceImpl implements YjfbService {

    @Autowired
    private TCmsYjfbMapper yjfbMapper;


    @Transactional(transactionManager = "masterTransactionManager",rollbackFor = Exception.class)
    @Override
    public String save(TCmsYjfb pojo) {
        if(yjfbMapper.insertSelective(pojo)>0){
            return JsonUtil.toSUCCESS("保存成功!","lbt-tab",true);
        }
        return JsonUtil.toERROR("保存失败!");
    }

    @Override
    public String update(TCmsYjfb pojo) {
        if(yjfbMapper.updateByPrimaryKeySelective(pojo)>0){
            return JsonUtil.toSUCCESS("操作成功!","lbt-tab",true);
        }
        return JsonUtil.toERROR("操作失败!");
    }

    @Override
    public String delete(Integer[] ids) {
        if(ids!=null&&ids.length>0){
            for(Integer id:ids){
                yjfbMapper.deleteByPrimaryKey(id);
                return JsonUtil.toSUCCESS("删除成功!","lbt-tab",true);
            }
        }
        return JsonUtil.toERROR("删除失败!");
    }

    @Override
    public TCmsYjfb findById(Integer id) {
        return yjfbMapper.selectByPrimaryKey(id);
    }

    @Override
    public List<TCmsYjfb> findList(TCmsYjfb pojo) {
        return yjfbMapper.select(pojo);
    }

    @Override
    public List<TCmsYjfb> findAll() {
        return yjfbMapper.selectAll();
    }

    @Override
    public PageInfo<TCmsYjfb> page(Integer pageNumber, Integer pageSize, TCmsYjfb pojo) {
        PageHelper.startPage(pageNumber,pageSize);
        return new PageInfo(yjfbMapper.selectByCondition(pojo));
    }



    @Override
    public PageInfo<TCmsYjfb> page(Integer pageNumber, Integer pageSize) {
        PageHelper.startPage(pageNumber,pageSize);
        return new PageInfo<>(findAll());
    }
}
