package com.sooka.module.web.cms.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sooka.common.utils.JsonUtil;
import com.sooka.module.web.cms.service.YjfbService;
import com.sooka.module.web.cms.service.ZrzcService;
import com.sooka.mybatis.mapper.TCmsZrzcMapper;
import com.sooka.mybatis.mapper.TCmsZrzcMapper;
import com.sooka.mybatis.model.TCmsContentDbt;
import com.sooka.mybatis.model.TCmsZrzc;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class  ZrzcServiceImpl implements ZrzcService {

    @Autowired
    private TCmsZrzcMapper zrzcMapper;


    @Override
    public String save(TCmsZrzc pojo) {
        if(zrzcMapper.insertSelective(pojo)>0){
            return JsonUtil.toSUCCESS("保存成功!","lbt-tab",true);
        }
        return JsonUtil.toERROR("保存失败!");
    }

    @Override
    public String update(TCmsZrzc pojo) {
        if(zrzcMapper.updateByPrimaryKeySelective(pojo)>0){
            return JsonUtil.toSUCCESS("操作成功!","lbt-tab",true);
        }
        return JsonUtil.toERROR("操作失败!");
    }


    @Override
    public String delete(Integer[] ids) {
        if(ids!=null&&ids.length>0){
            for(Integer id:ids){
                zrzcMapper.deleteByPrimaryKey(id);
                return JsonUtil.toSUCCESS("删除成功!","lbt-tab",true);
            }
        }
        return JsonUtil.toERROR("删除失败!");
    }

    @Override
    public TCmsZrzc findById(Integer id) {
        return zrzcMapper.selectByPrimaryKey(id);
    }

    @Override
    public List<TCmsZrzc> findList(TCmsZrzc pojo) {
        return zrzcMapper.select(pojo);
    }

    @Override
    public List<TCmsZrzc> findAll() {
        return zrzcMapper.selectAll();
    }

    @Override
    public PageInfo<TCmsZrzc> page(Integer pageNumber, Integer pageSize, TCmsZrzc pojo) {
        PageHelper.startPage(pageNumber,pageSize);
        return new PageInfo(findAll());
    }



    @Override
    public PageInfo<TCmsZrzc> page(Integer pageNumber, Integer pageSize) {
        PageHelper.startPage(pageNumber,pageSize);
        return new PageInfo<>(findAll());
    }
}
