package com.sooka.module.web.system;

import com.github.pagehelper.PageInfo;
import com.sooka.common.base.BaseController;
import com.sooka.common.constant.CmsConst;
import com.sooka.common.utils.CmsUtil;
import com.sooka.common.utils.ControllerUtil;
import com.sooka.module.web.system.service.IPConfigService;
import com.sooka.module.web.system.vo.UserVo;
import com.sooka.mybatis.model.TSysIPConfig;
import java.sql.SQLException;
import org.apache.shiro.authz.UnauthenticatedException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;


/**
 * 
 * @author Administrator
 *
 */
@Controller
@RequestMapping("/system/ipConfig")
public class IPConfigController extends BaseController<TSysIPConfig>{
	
	 @Autowired
	 private IPConfigService ipConfigService;

	/**
	 * ip黑名单列表
	 */
	@Override
    @RequestMapping
    public String index(@RequestParam(value = "pageCurrent",defaultValue = "1") Integer pageNumber,  
    		@RequestParam(value = "pageSize",defaultValue = "20")Integer pageSize, TSysIPConfig pojo, Model model){
    	UserVo userVo = ((UserVo) ControllerUtil.getHttpSession().getAttribute(CmsConst.SITE_USER_SESSION_KEY));
        if(CmsUtil.isNullOrEmpty(userVo)) {
        	System.out.println("无登录信息");
            throw new UnauthenticatedException();
        }
        model.addAttribute("pojo",pojo);
        model.addAttribute("model",ipConfigService.page(pageNumber, pageSize, pojo));
        return "system/ipconfig_list";

    }

	@Override
	@RequestMapping("/input")
	public String input(@RequestParam(value = "id",required = false) Integer Id, Model model) {
		if(Id!=null) {
            model.addAttribute("ip",ipConfigService.findById(Id));
        }
        return "system/ipconfig_input";
	}

	@Override
	@RequestMapping("/save")
    @ResponseBody
	public String save(TSysIPConfig pojo) throws SQLException {
		UserVo userVo = ((UserVo) ControllerUtil.getHttpSession().getAttribute(CmsConst.SITE_USER_SESSION_KEY));
		pojo.setUserId(userVo.getUserId());
		pojo.setUserName(userVo.getUsername());
		if(pojo.getId()!=null) {
            return ipConfigService.update(pojo);
        }
        return ipConfigService.save(pojo);
	}

	@Override
	@RequestMapping("/delete")
    @ResponseBody
	public String delete(@RequestParam(value = "ids",required = false) Integer[] ids) throws SQLException {
		return ipConfigService.delete(ids);
	}

}
