package com.sooka.module.web.system.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sooka.common.utils.CmsUtil;
import com.sooka.common.utils.JsonUtil;
import com.sooka.module.web.system.service.IPConfigService;
import com.sooka.mybatis.mapper.TSysIPConfigMapper;
import com.sooka.mybatis.model.TSysIPConfig;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 
 * @author Administrator
 *
 */
@Service
public class IPConfigServiceImpl implements IPConfigService {
	
	@Autowired
	private TSysIPConfigMapper iPConfigMapper;

	@Override
	public String save(TSysIPConfig pojo) {
		if(iPConfigMapper.insertSelective(pojo)>0) {
            return JsonUtil.toSUCCESS("操作成功！","ipconfig-tab",true);
        }
        return JsonUtil.toERROR("操作失败！");
	}

	@Override
	public String update(TSysIPConfig pojo) {
		if(iPConfigMapper.updateByPrimaryKeySelective(pojo)>0) {
            return JsonUtil.toSUCCESS("操作成功！","ipconfig-tab",false);
        }
        return JsonUtil.toERROR("操作失败！");
	}

	@Override
	public String delete(Integer[] ids) {
		if(CmsUtil.isNullOrEmpty(ids)) {
            return JsonUtil.toERROR("操作失败！");
        }
        for(Integer id : ids) {
        	iPConfigMapper.deleteByPrimaryKey(id);
        }
        return JsonUtil.toSUCCESS("操作成功！","ipconfig-tab",false);
	}

	@Override
	public TSysIPConfig findById(Integer id) {
		return iPConfigMapper.selectByPrimaryKey(id);
	}

	@Override
	public List<TSysIPConfig> findList(TSysIPConfig pojo) {
		return iPConfigMapper.select(pojo);
	}

	@Override
	public List<TSysIPConfig> findAll() {
		return iPConfigMapper.selectAll();
	}

	@Override
	public PageInfo<TSysIPConfig> page(Integer pageNumber, Integer pageSize, TSysIPConfig pojo) {
		PageHelper.startPage(pageNumber,pageSize);
        return new PageInfo<>(this.findList(pojo));
	}

	@Override
	public PageInfo<TSysIPConfig> page(Integer pageNumber, Integer pageSize) {
		PageHelper.startPage(pageNumber,pageSize);
        return new PageInfo<>(this.findAll());
	}

	@Override
	public Integer AllCount() {
		return this.iPConfigMapper.selectCount(new TSysIPConfig());
	}

}
