package com.sooka.mybatis.mapper;

import com.sooka.module.web.cms.vo.TCmsEnterpriseHmdVo;
import com.sooka.mybatis.model.TCmsEnterpriseHmd;
import org.apache.ibatis.annotations.*;
import tk.mybatis.mapper.common.Mapper;

import java.util.List;
import java.util.Map;

public interface TCmsEnterpriseHmdMapper extends Mapper<TCmsEnterpriseHmd> {

    /*根据站点编号删除内容*/
    @Delete("delete from cms.t_cms_content where site_id = #{siteId}")
    int deleteBySiteId(@Param("siteId") Integer siteId);

    List<TCmsEnterpriseHmd> selectByCondition(TCmsEnterpriseHmd content);
    List<TCmsEnterpriseHmd> selectByCondition(TCmsEnterpriseHmdVo content);

    List<TCmsEnterpriseHmd> selectByTableNameAndMap(@Param("tableName") String tableName, @Param("categoryId") Long categoryId, @Param("param") Map param);

    Map selectByContentIdAndTableName(@Param("contentId") Long contentId,
                                      @Param("tableName") String tableName);

    List<Map> selectByContentListBySiteIdAndCategoryIds(@Param("siteId") Integer siteId,
                                                        @Param("categoryIds") Long[] categoryIds,
                                                        @Param("orderBy") Integer orderBy,
                                                        @Param("isHot") Integer isHot,
                                                        @Param("isPic") Integer isPic,
                                                        @Param("isRecommend") Integer isRecommend,
                                                        @Param("tableName") String tableName
    );



    List<Map> selectByTopicContentListBySiteIdAndCategoryIds(@Param("siteId") Integer siteId,
                                                             @Param("categoryIds") Long[] categoryIds,
                                                             @Param("orderBy") Integer orderBy,
                                                             @Param("isHot") Integer isHot,
                                                             @Param("isPic") Integer isPic,
                                                             @Param("isRecommend") Integer isRecommend
    );


}